/*
 * @Descripttion: 
 * @version: 
 * @Author: TT
 * @Date: 2021-11-30 22:26:22
 * @LastEditors: ftt
 * @LastEditTime: 2022-04-16 11:52:25
 */

import 'package:flutter/material.dart';

import '../../ttcomment.dart';
import 'normal_no_splash_factory.dart';

//创建Dark ThemeData对象
final ThemeData appDarkThemeData = ThemeData(
  brightness: Brightness.dark,
  primaryColor: CommentColorS.col010101,
  splashColor: Colors.white.withOpacity(0),
  splashFactory: const NormalNoSplashFactory(),
  highlightColor: Colors.white.withOpacity(0),
  scaffoldBackgroundColor:
      CommentColorS.col010101, //Scaffold的背景颜色。典型Material应用程序或应用程序内页面的背景颜色
  textTheme: const TextTheme(
    headline5: TextStyle(
        color: CommentColorS.colffffff,
        fontWeight: FontWeight.bold,
        fontSize: 24),
    bodyText1: TextStyle(
      color: CommentColorS.colffffff,
      fontSize: 16.0,
    ),
    bodyText2: TextStyle(
      color: CommentColorS.colffffff,
      fontSize: 14,
    ),
  ),
  appBarTheme: const AppBarTheme(
    iconTheme: IconThemeData(color: Colors.white),
    backgroundColor: CommentColorS.col010101,
  ),
);

//创建light ThemeData对象
final ThemeData appLightThemeData = ThemeData(
  brightness: Brightness.light,
  primaryColor: CommentColorS.colffffff,
  splashColor: Colors.white.withOpacity(0),
  highlightColor: Colors.white.withOpacity(0),
  splashFactory: const NormalNoSplashFactory(),
  scaffoldBackgroundColor:
      CommentColorS.colffffff, //Scaffold的背景颜色。典型Material应用程序或应用程序内页面的背景颜色
  textTheme: const TextTheme(

      /// 字体24
      headline5: TextStyle(
        color: CommentColorS.col333333,
        fontWeight: FontWeight.bold,
      ),
      bodyText1: TextStyle(
        color: CommentColorS.col333333,
        fontSize: 16.0,
      ),
      bodyText2:
          TextStyle(color: CommentColorS.col333333, fontSize: 14)), // 字体主题
  appBarTheme: const AppBarTheme(
    iconTheme: IconThemeData(color: Colors.black),
    backgroundColor: Colors.white,
  ),
);
