/*
 * @Description: 
 * @Version: 2.0
 * @Autor: ftt
 * @Date: 2022-04-22 11:44:52
 * @LastEditors: TT
 * @LastEditTime: 2022-06-22 22:45:33
 */
/*
 * @Description: 
 * @Version: 2.0
 * @Autor: ftt
 * @Date: 2022-04-20 14:24:05
 * @LastEditors: ftt
 * @LastEditTime: 2022-04-20 15:20:31
 */

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

import '../ttcomment.dart';

/*
 * @description: 默认弹框
 * @param
 * {
 *    title: 提示语
 *    msg: 显示内容
 *    cannermsg: 取消按钮文字
 *    suremsg: 确定按钮文字
 *    btntype:  按钮样式 1 两个按钮 2 一个按钮
 *    barrierDismissible: 点击屏幕关闭弹框
 * }
 * @return {*}
 */
showPermissionpopup(
    {required BuildContext context,
    String? title,
    String? msg,
    String? suremsg = "同意",
    String? cannermsg = "我不同意",
    int btntype = 1,
    Widget? titlewidget,
    Widget? msgwidget,
    bool barrierDismissible = true,
    Widget? child,
    Color? dialogBackColor,
    Function()? ontapsure,
    Function()? ontapcanner}) {
  showDialog(
    context: context,
    barrierDismissible: barrierDismissible,
    builder: (BuildContext context) {
      return Dialog(
        backgroundColor: dialogBackColor,
        shape: RoundedRectangleBorder(
          borderRadius: BorderRadius.all(
            Radius.circular(
              15.r,
            ),
          ),
        ),
        child: child ??
            PopDialogWidget(
              context: context,
              title: title,
              msg: msg,
              titlewidget: titlewidget,
              msgwidget: msgwidget,
              cannermsg: cannermsg,
              suremsg: suremsg,
              ontapcanner: () {
                if (ontapcanner != null) {
                  ontapcanner();
                } else {
                  Navigator.of(context).pop();
                }
              },
              ontapsure: () {
                if (ontapsure != null) {
                  ontapsure();
                } else {
                  Navigator.of(context).pop();
                }
              },
            ),
      );
    },
  );
}

/*
 * @description:创建通用弹框界面
 * @param
 * {
 *    title: 提示语
 *    msg: 显示内容
 *    cannermsg: 取消按钮文字
 *    suremsg: 确定按钮文字
 * 
 *    btntype:  按钮样式 1 两个按钮 2 一个按钮
 *    ontapsure type 0 取消 1 确定
 * }
 * @return {*}
 */
// ignore: non_constant_identifier_names
Widget PopDialogWidget(
    {required BuildContext context,
    String? title,
    Widget? titlewidget,
    Widget? msgwidget,
    String? msg,
    String? cannermsg,
    String? suremsg,
    Color? surebackgrounColor,
    Widget? sureWidget,
    Widget? cannerWidget,
    int btntype = 1,
    Function()? ontapsure,
    Function()? ontapcanner}) {
  return Padding(
    padding: EdgeInsets.all(20.w),
    child: Column(
      mainAxisSize: MainAxisSize.min,
      children: [
        titlewidget ??
            Text(
              title ?? "",
              style: TextStyleMacor.fontBold(
                16,
                CommentColorS.col222222,
              ),
              textAlign: TextAlign.center,
            ),
        title == null ? Gaps.vGap5 : Gaps.vGap10,
        msgwidget ??
            Text(
              msg ?? "",
              style: TextStyleMacor.fontBold(
                16,
                CommentColorS.col222222,
              ),
            ),
        Gaps.vGap35,
        CreateSureAndCannerBtnWidget(
          cannermsg: cannermsg,
          suremsg: suremsg,
          btntype: btntype,
          ontapcanner: ontapcanner,
          surebackgrounColor: surebackgrounColor,
          sureWidget: sureWidget,
          cannerWidget: cannerWidget,
          ontapsure: ontapsure,
        )
      ],
    ),
  );
}

/*
 * @description: 创建 通用的两个按钮
 * @param {
 *    cannermsg: 取消按钮文字
 *    suremsg: 确定按钮文字
 *    btntype:  按钮样式 1 两个按钮 2 一个按钮
 *    ontapsure type 0 取消 1 确定}
 * @return {*}
 */
// ignore: non_constant_identifier_names
CreateSureAndCannerBtnWidget({
  String? cannermsg,
  String? suremsg,
  Color? surebackgrounColor,
  Widget? sureWidget,
  Widget? cannerWidget,
  int btntype = 1,
  Function()? ontapsure,
  Function()? ontapcanner,
}) {
  return Row(
    mainAxisAlignment: MainAxisAlignment.spaceBetween,
    children: [
      btntype == 1
          ? cannerWidget ??
              BtnItemWidget(
                BtnlayoutType.text,
                title: Container(
                  alignment: Alignment.center,
                  width: 118.w,
                  height: 40.w,
                  decoration: BoxDecoration(
                    color: CommentColorS.colf5f5f5,
                    borderRadius: BorderRadius.all(
                      Radius.circular(20.r),
                    ),
                  ),
                  child: Text(
                    cannermsg ?? "",
                    style: TextStyleMacor.fontBold(14, CommentColorS.col999999),
                  ),
                ),
                ontap: () {
                  if (ontapcanner != null) {
                    ontapcanner();
                  }
                },
              )
          : Container(),
      sureWidget ??
          BtnItemWidget(
            BtnlayoutType.text,
            title: Container(
              alignment: Alignment.center,
              width: 118.w,
              height: 40.w,
              decoration: BoxDecoration(
                  borderRadius: BorderRadius.all(
                    Radius.circular(20.r),
                  ),
                  color: surebackgrounColor ?? CommentColorS.col2865ff),
              child: Text(
                suremsg ?? "",
                style: TextStyleMacor.fontBold(14, CommentColorS.colffffff),
              ),
            ),
            ontap: () {
              if (ontapsure != null) {
                ontapsure();
              }
            },
          )
    ],
  );
}
